"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const aurelia_dependency_injection_1 = require("aurelia-dependency-injection");
const aurelia_framework_1 = require("aurelia-framework");
const aurelia_typed_observable_plugin_1 = require("aurelia-typed-observable-plugin");
aurelia_typed_observable_plugin_1.usePropertyTypeForBindable(true);
aurelia_typed_observable_plugin_1.usePropertyTypeForObservable(true);
const VIEW_ACTIVE_LEAVE_CLASS = "au-leave-active";
let PiView = class PiView {
    constructor(_rootElement, _queue) {
        this._rootElement = _rootElement;
        this._queue = _queue;
        this._animationReady = false;
        this._isOnline = navigator.onLine;
        this._scopedOnlineMethod = this._onOnline.bind(this);
        this._scopedOfflineMethod = this._onOffline.bind(this);
    }
    get innerElement() {
        return this._innerElement;
    }
    scrollTo(target, offset = 16) {
        const viewElement = this._rootElement;
        const position = target instanceof HTMLElement ? Math.max(0, target.offsetTop - offset) : target;
        viewElement.scrollTo({
            behavior: "smooth",
            left: 0,
            top: position
        });
    }
    attached() {
        window.addEventListener("online", this._scopedOnlineMethod);
        window.addEventListener("offline", this._scopedOfflineMethod);
        this._setAnimationListener();
        this._queue.queueMicroTask(() => {
            this.onReady && this.onReady({ component: this });
        });
    }
    detached() {
        window.removeEventListener("online", this._scopedOnlineMethod);
        window.removeEventListener("offline", this._scopedOfflineMethod);
    }
    _willBeAnimated() {
        const siblings = [...this._rootElement.parentElement.children];
        return siblings.some(sibling => sibling !== this._rootElement && sibling.classList.contains(VIEW_ACTIVE_LEAVE_CLASS));
    }
    _setAnimationListener() {
        if (!this._willBeAnimated()) {
            this._onAnimationEnd();
            return;
        }
        this._rootElement.addEventListener("animationend", this._onAnimationEnd.bind(this), { once: true });
    }
    _onAnimationEnd() {
        this._animationReady = true;
        this.onAnimated && this.onAnimated({ component: this });
    }
    _onOnline() {
        return __awaiter(this, void 0, void 0, function* () {
            this._isOnline = true;
            this.onOnline && this.onOnline({ component: this });
        });
    }
    _onOffline() {
        return __awaiter(this, void 0, void 0, function* () {
            this._isOnline = false;
            this.onOffline && this.onOffline({ component: this });
        });
    }
};
__decorate([
    aurelia_typed_observable_plugin_1.bindable,
    __metadata("design:type", Boolean)
], PiView.prototype, "noScrolling", void 0);
__decorate([
    aurelia_typed_observable_plugin_1.bindable,
    __metadata("design:type", Boolean)
], PiView.prototype, "noInteraction", void 0);
__decorate([
    aurelia_typed_observable_plugin_1.bindable,
    __metadata("design:type", Function)
], PiView.prototype, "onOnline", void 0);
__decorate([
    aurelia_typed_observable_plugin_1.bindable,
    __metadata("design:type", Function)
], PiView.prototype, "onOffline", void 0);
__decorate([
    aurelia_typed_observable_plugin_1.bindable,
    __metadata("design:type", Function)
], PiView.prototype, "onAnimated", void 0);
__decorate([
    aurelia_typed_observable_plugin_1.bindable,
    __metadata("design:type", Function)
], PiView.prototype, "onReady", void 0);
PiView = __decorate([
    aurelia_dependency_injection_1.autoinject,
    aurelia_framework_1.viewResources(aurelia_framework_1.PLATFORM.moduleName("./pi-view.css")),
    __metadata("design:paramtypes", [Element,
        aurelia_framework_1.TaskQueue])
], PiView);
exports.PiView = PiView;

//# sourceMappingURL=pi-view.js.map
