"use strict";
function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
Object.defineProperty(exports, "__esModule", { value: true });
const aurelia_framework_1 = require("aurelia-framework");
const aurelia_typed_observable_plugin_1 = require("aurelia-typed-observable-plugin");
const configuration_1 = require("./configuration");
let initialized = false;
function configure(frameworkConfig, callback) {
    if (initialized) {
        return;
    }
    frameworkConfig.plugin(aurelia_framework_1.PLATFORM.moduleName("aurelia-animator-css"))
        .plugin(aurelia_framework_1.PLATFORM.moduleName("aurelia-fetch-client"))
        .plugin(aurelia_framework_1.PLATFORM.moduleName("aurelia-typed-observable-plugin"))
        .globalResources([
        aurelia_framework_1.PLATFORM.moduleName("./elements/pi-app"),
        aurelia_framework_1.PLATFORM.moduleName("./elements/pi-view"),
    ])
        .postTask(() => {
        aurelia_typed_observable_plugin_1.coerceFunctions.boolean = value => value === undefined ? value : value !== false;
        aurelia_typed_observable_plugin_1.coerceFunctions.string = value => value === undefined ? value : value.toString();
        aurelia_typed_observable_plugin_1.coerceFunctions.number = value => value === undefined ? value : parseFloat(value);
        aurelia_typed_observable_plugin_1.coerceFunctions.Function = aurelia_typed_observable_plugin_1.coerceFunctions.function;
        aurelia_typed_observable_plugin_1.coerceFunctions.numberOrString = value => {
            if (value === undefined) {
                return;
            }
            const toNumber = parseFloat(value);
            return isNaN(toNumber) ? value.toString() : toNumber;
        };
    });
    aurelia_typed_observable_plugin_1.usePropertyTypeForBindable(true);
    aurelia_typed_observable_plugin_1.usePropertyTypeForObservable(true);
    const config = aurelia_framework_1.Container.instance.get(configuration_1.PitayaConfiguration);
    callback instanceof Function && callback(config);
    initialized = true;
    config.initialized = true;
}
exports.configure = configure;
__export(require("./elements/pi-app"));
__export(require("./elements/pi-view"));
__export(require("./helpers/decorators"));
__export(require("./helpers/utils"));
__export(require("./configuration"));

//# sourceMappingURL=index.js.map
