var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import { HttpClient } from "aurelia-fetch-client";
import { PLATFORM } from "aurelia-framework";
const httpClient = new HttpClient();
const _GUID_PREFIX = "pty-";
let _idCounter = 0;
export const delay = function (ms) {
    return new Promise((resolve) => window.setTimeout(resolve, ms));
};
export const nextAnimationFrame = function () {
    return new Promise((resolve) => requestAnimationFrame(resolve));
};
export const nextEventRaise = function (element, eventName) {
    return new Promise((resolve) => {
        const callback = ({ srcElement }) => {
            if (srcElement !== element) {
                return;
            }
            element.removeEventListener(eventName, callback);
            resolve();
        };
        element.addEventListener(eventName, callback);
    });
};
export const createElement = function (htmlString) {
    const template = document.createElement("template");
    template.innerHTML = htmlString.trim();
    return template.content.firstChild;
};
export const getJSON = (url) => __awaiter(void 0, void 0, void 0, function* () {
    const response = yield httpClient.fetch(PLATFORM.moduleName(url));
    const status = response.status;
    if (status >= 200 && status < 300) {
        return response.json();
    }
    else {
        throw {
            status,
            body: yield response.json()
        };
    }
});
export const generateGUID = function () {
    return `${_GUID_PREFIX}${_idCounter++}`;
};

//# sourceMappingURL=utils.js.map
